/////////////////////////////////////////////////////////////////////
//Beispiel für ein Federpendel in Kapitel Simulation
///////////////////////////////////////////////////////////////////////

ArrayList<Float> funcVals = new ArrayList<Float>();//Werte für die amplitude der Masse
ArrayList<Float> sinVals = new ArrayList<Float>(); //Zum Vergleich: Werte einer angepassten Sinusfunktion

float ruheLaenge=200;
float federKonstante=0.02;
float zeitIntervall=0.4;
float amplitude=100;
float masse=1;
Pendel pendel;

boolean showSinus = false;
// Startpunkt von Pendel und sinus-Funktionswerten
float fy0=30+ruheLaenge;//Ruhelage

void setup() { 
  size(1000, 500);
  pendel = new Pendel(width-100, 30, ruheLaenge, federKonstante,masse);
  pendel.setzeAnfangszustand(width-100, fy0+amplitude);//Das Pendel startet am unteren Umkehrpunkt
}

void draw() {
  background(255);

  pendel.aktualisieren();
  pendel.display();
  funcVals.add(new Float(pendel.getY1()));
  
  // die der Simulation identische Sinusfunktion
  // die Konstante PI/2 ist nötig, weil die Simulation schon ausgelenkt beginnt, man hätte
  // stattdessen auch den Cosinus nehmen können
  // Funktion nun so anpassen, dass sie der Simulation entspricht
  sinVals.add(new Float(amplitude*sin(PI/2+sqrt(federKonstante/masse)*frameCount*zeitIntervall)));
  // zeige den Verlauf der Pendelbeweung über die Zeit
  noFill();
  stroke(0, 0, 255);
  beginShape();
  for (int i=0; i<funcVals.size(); i++) {
    float x = width-100+2*(i-funcVals.size());
    if (x>100) vertex(x, funcVals.get(i));
   }
  endShape();
  
  // zeige die Sinuswerte als Überlagerung über die Simulation
  if (showSinus) {
    stroke(255,0,0);
    beginShape();
     for (int i=0; i<funcVals.size(); i++) {
       float x = width-100+2*(i-funcVals.size());
       if (x>100) vertex(x, fy0+sinVals.get(i));
     }
    endShape();
  }
}

void keyPressed() {
  if (key == 'f') showSinus = !showSinus;
  if (key == 's') save("test.png");
}